"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styles = require("@material-ui/core/styles");

var _JssProvider = _interopRequireDefault(require("react-jss/lib/JssProvider"));

var _getInitialProps3 = _interopRequireDefault(require("../util/getInitialProps"));

var _getContext = _interopRequireDefault(require("../util/getContext"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * inject Mui Theme
 * @param {object} theme 
 */
var withMuiTheme = function withMuiTheme(theme) {
  return function (BaseComponent) {
    var InjectMuiTheme =
    /*#__PURE__*/
    function (_PureComponent) {
      _inherits(InjectMuiTheme, _PureComponent);

      function InjectMuiTheme(props) {
        var _this;

        _classCallCheck(this, InjectMuiTheme);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(InjectMuiTheme).call(this, props));

        _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "pageContext", null);

        _this.pageContext = props.pageContext || (0, _getContext.default)(theme);
        return _this;
      }

      _createClass(InjectMuiTheme, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          // Remove the server-side injected CSS.
          var jssStyles = document.querySelector('#jss-server-side');

          if (jssStyles && jssStyles.parentNode) {
            jssStyles.parentNode.removeChild(jssStyles);
          }
        }
      }, {
        key: "render",
        value: function render() {
          // eslint-disable-next-line react/destructuring-assignment
          var pageContext = this.props.pageContext || this.pageContext;
          return _react.default.createElement(_JssProvider.default, {
            registry: pageContext.sheetsRegistry,
            generateClassName: pageContext.generateClassName
          }, _react.default.createElement(_styles.MuiThemeProvider, {
            theme: pageContext.theme,
            sheetsManager: pageContext.sheetsManager
          }, _react.default.createElement(BaseComponent, _extends({}, this.props, {
            pageContext: pageContext
          }))));
        }
      }], [{
        key: "getInitialProps",
        value: function () {
          var _getInitialProps2 = _asyncToGenerator(
          /*#__PURE__*/
          _regenerator.default.mark(function _callee(context) {
            var props;
            return _regenerator.default.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return (0, _getInitialProps3.default)(BaseComponent, context);

                  case 2:
                    props = _context.sent;
                    return _context.abrupt("return", _objectSpread({}, props));

                  case 4:
                  case "end":
                    return _context.stop();
                }
              }
            }, _callee, this);
          }));

          return function getInitialProps(_x) {
            return _getInitialProps2.apply(this, arguments);
          };
        }()
      }]);

      return InjectMuiTheme;
    }(_react.PureComponent);

    InjectMuiTheme.defaultProps = {
      pageContext: null
    };
    return InjectMuiTheme;
  };
};

var _default = withMuiTheme;
exports.default = _default;
module.exports = exports.default;