"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultParts = exports.default = void 0;

var _compose = _interopRequireDefault(require("../util/compose"));

var _withLayout = _interopRequireDefault(require("./withLayout"));

var _withMuiTheme = _interopRequireDefault(require("./withMuiTheme"));

var _withProgressBar = _interopRequireDefault(require("./withProgressBar"));

var _withCssBaseline = _interopRequireDefault(require("./withCssBaseline"));

var _defaultTheme = _interopRequireDefault(require("./defaultTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var withParts = function withParts() {
  var muiTheme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var Layout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var enableNProgress = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var enableDefaultCssBaseline = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
  var layoutHoc = Layout != null ? (0, _withLayout.default)(Layout) : null;
  var muiThemeHoc = (0, _withMuiTheme.default)(muiTheme || _defaultTheme.default);
  var progressBarHoc = enableNProgress ? _withProgressBar.default : null;
  var cssBaselineHoc = enableDefaultCssBaseline ? _withCssBaseline.default : null;
  return (0, _compose.default)(progressBarHoc, muiThemeHoc, cssBaselineHoc, // inject global css before muiTheme
  layoutHoc);
};

var _default = withParts;
exports.default = _default;
var defaultParts = withParts();
exports.defaultParts = defaultParts;