"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = makeNextExportPathMap;

var R = _interopRequireWildcard(require("ramda"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var nilToEmpty = function nilToEmpty(elem) {
  return R.isNil(elem) ? '' : elem;
};

var toArray = function toArray(elem) {
  return Array.isArray(elem) ? elem : [elem];
};

var formatToNextPathmap = function formatToNextPathmap(uri) {
  return [uri, {
    page: uri
  }];
};

function getUriList(basicUri, nameList) {
  var composeUri = R.curry(function (base, subPath) {
    return "/".concat(base).concat(subPath === '' ? '' : "/".concat(subPath));
  })(basicUri);
  var makeRealUri = R.compose(composeUri, nilToEmpty);
  return R.compose(R.map(makeRealUri), toArray)(nameList);
}
/**
 * Flat pathMap to OBJECT which can be used to
 * create static next.js site.
 *
 * The flatten OBJECT: { 'name of path': { page: 'absolute path'} }
 * 
 * @param {*array} pathMap [{pathname: pathname, children: null or array of subpath}]
 */


function makeNextExportPathMap(pathMap) {
  if (!Array.isArray(pathMap)) return {};
  var makeNextPathmapUriList = R.compose(R.apply(getUriList), R.props(['pathname', 'children']));
  var allPathMap = R.compose(R.fromPairs, R.map(formatToNextPathmap), R.flatten, R.concat(['/']), // add root path
  R.map(makeNextPathmapUriList))(pathMap);
  return allPathMap;
}

module.exports = exports.default;